<?php

$debug=0;

include("sprintpcscommon.php");

if (array_key_exists("PROFILE",$_GET))
     $profile=$_GET["PROFILE"];
else
     die('No profile!');

if (array_key_exists("DAYSBACK",$_GET))
     $daysback=$_GET["DAYSBACK"];
else
     $daysback=30;

if (array_key_exists("WIDTH",$_GET))
     $width=$_GET["WIDTH"];
     else
     $width=200;

if (array_key_exists("HEIGHT",$_GET))
     $height=$_GET["HEIGHT"];
     else
     $height=150;

/*
$profile="eolson";
$daysback=30;
$width=200;
$height=150;
*/

$confpath=$SPRINTPREFIX.$profile.".conf";
$conf=readconfig($confpath);

//var_dump($conf);

$historypath=$SPRINTPREFIX.$profile."history.txt";
//$historypath="/tmp/foo.txt";
$fd=fopen($historypath,"r");
if (!$fd)
{
  print "couldn't open history file";
  exit();
}

$daywidth=$width/$daysback;

//print "$daywidth $width $daysback";

$extraheight=imagefontheight(2)*2;
$im=imagecreate($width,$height+$extraheight);

$white=imagecolorallocate($im,255,255,255);
$black=imagecolorallocate($im,0,0,0);
$yellow=imagecolorallocate($im,255,255,0);
$blue=imagecolorallocate($im,200,80,255);
$red=imagecolorallocate($im,255,0,0);
$dkgray=imagecolorallocate($im,45,45,45);
imagefilledrectangle($im,0,0,$width,$height+$extraheight,$black);
//imagecolortransparent($im,$black);

$colors=array("MINUTES IN PLAN"=>imagecolorallocate($im,255,0,0),
	     "OFF-PEAK OPTION"=>imagecolorallocate($im,0,0,255),
	     "OTHER"=>imagecolorallocate($im,0,128,128));

$d=array();

if ($debug) 
     print "starting ".time();

while (!feof($fd))
{
  $line=fgets($fd,8192);
  if (is_string($line))
    {
      $a=unserialize($line);
      $d[]=$a;
    }
}

if ($debug)
     print "done reading".time();

$todaytime=time();
$todaydate=getdate($todaytime);

$starttime=$todaytime-60*60*24*$daysback;
$startdate=getdate($starttime);
$starttime=mktime(0,0,0,$startdate["mon"],$startdate["mday"],$startdate["year"]);

$todaytime=mktime(23,59,59,$todaydate["mon"],$todaydate["mday"],$todaydate["year"]);

//print date("r",$starttime)." ".date("r",$todaytime);

/* determine vertical scaling. Scale factor should be
   max(1.0,most-minutes-used/minutes-in-plan) */

$vscale=1;

$cand=maximumscale($d,"MINUTES IN PLAN");
if ($cand>$vscale)
     $vscale=$cand;

$cand=maximumscale($d,"OFF-PEAK OPTION");

if ($cand>$vscale)
     $vscale=$cand;

     //     $vscale*=1.1;
     //          $vscale=intval($vscale*10+5)/10;

/** draw dark grey vertical bars every 24 hours. */
for ($i=0;$i<$daysback+1;$i++)
{
  $t=$todaytime-$i*3600*24;
  $x=$width-$width*($t-$starttime)/($todaytime-$starttime);
  //    print " $x <br>";
  imageline($im,$x,0,$x,$height,$dkgray);
}

/** draw vertical scale */
$steps=5;
for ($i=0;$i<=$steps;$i++)
{
  $frac=$i/$steps;
  $y=$height-$frac*$height;
  
  $m=$d[0]["minutes"]["MINUTES IN PLAN"]["plan"];
  imagestring($im,2,5,$y,intval($vscale*$m*$frac),$yellow);

  $m=$d[0]["minutes"]["OFF-PEAK OPTION"]["plan"];
  imagestring($im,2,imagefontwidth(2)*5,$y,intval($vscale*$m*$frac),$blue);

  imageline($im,0,$y,$width,$y,$dkgray);
}

if ($debug)
     print "before plot ".time();

/** draw legend at bottom */
imagestring($im,2,$width/2,$height+imagefontheight(2)/2,"Peak",$yellow);
imagestring($im,2,3*$width/4,$height+imagefontheight(2)/2,"Off-Peak",$blue);

plotminutes($im,$width,$height,"OFF-PEAK OPTION",$vscale,
	    $blue,$red,$black,
	    $d,$todaytime,$starttime);

if ($debug)
     print "done off-peak ".time();

plotminutes($im,$width,$height,"MINUTES IN PLAN",$vscale,
	    $yellow,$red,$black,
	    $d,$todaytime,$starttime);

if ($debug)
     print "done ".time();

header("Content-type: image/png");
imagepng($im);


function maximumscale($data,$type)
{
  $vscale=1;

  foreach ($data as $a)
    {
      if ($a["minutes"][$type]["plan"]>0)
	$cand=$a["minutes"][$type]["used"]/$a["minutes"][$type]["plan"];
      else
	$cand=1;

      if ($cand>$vscale)
	$vscale=$cand;
    }

  return $vscale;
}

function plotminutes($im,$width,$height,$minutetype,$vscale,
		     $fgcolor,$expcolor,$bgcolor,
		     $data,$endtime,$starttime)
{

 $lastx=0;
 $lasty=0;
 $lastupdatetime="";
 
 $bgpattern=array($expcolor,$expcolor,$expcolor,
		  $bgcolor,$bgcolor,$bgcolor);

 $lastcyclestart=-1;

foreach ($data as $a)
  {
    $value=$a["minutes"][$minutetype];

    // this if statement can become just the first clause, since only
    // ed's data is missing some updatetime fields.
    if (array_key_exists("updatetime",$a))
      $updatetime=$a["updatetime"];
    else
      $updatetime=$a["currentasoftime"];


    // force update times to be monotonic. (Helps deal with Sprint returning bogus times)
    if ($updatetime<$lastupdatetime)
      $updatetime=$lastupdatetime+1;

    $lastupdatetime=$updatetime;
    
    $x=$width*($updatetime-$starttime)/($endtime-$starttime);
    if ($vscale>0 && $value["plan"]>0)
      $y=$height-$value["used"]*$height/$value["plan"]/$vscale;
    else
      $y=0;

    // skip invalid data
    if ($x<0 || $x>$width)
      continue;

    $x=clamp($x,0,$width);
    $y=clamp($y,0,$height);

    if ($lastx==0 && $lasty==0)
      {
	$lastx=$x;
	$lasty=$y;
      }

    // draw the dotted-red cycle line if we're into a new monthly cycle.
    if ($lastcyclestart<$a["starttime"])
      {
	$lastcyclestart=$a["starttime"];

	// the cycles appear to end around noon. Sprint only reports to the day, so
	// we fudge our numbers here.
	//	$fudge=60*60*12;
	$fudge=0;

	$a["starttime"]-=$fudge;
	$a["endtime"]+=$fudge;
	
	$xl=$width*($a["starttime"]-$starttime)/($endtime-$starttime);
	$xr=$width*($a["endtime"]-$starttime)/($endtime-$starttime);
	$yl=$height;
	$yr=$height-$height/$vscale;

	imagesetstyle($im,$bgpattern);
	imageline($im,$xl,$yl,$xr,$yr,IMG_COLOR_STYLED);
	imageline($im,$xr,$yr,$xr,$height,IMG_COLOR_STYLED);
	//		print "$xl $xr $yl $yr<br>";
      }
    
    // deglitch the output. (Sometimes Sprint seems to go back in time)
    // this shouldn't happen any more since we use updatetime
    if ($x<$lastx)
      continue;

    imageline($im,$lastx,$lasty,$x,$y,$fgcolor);
    //    imagefilledellipse($im,$x,$y,5,5,$fgcolor);
    
    $lastx=$x;
    $lasty=$y;
  }
}

function clamp($in, $min, $max)
{
  if ($in>$max)
    return $max;
  if ($in<$min)
    return $min;
  return $in;
}
?>